package fr.username404.snowygui.forge

import fr.username404.snowygui.Snowy
import fr.username404.snowygui.config.SnowyConfigScreen
import fr.username404.snowygui.gui.feature.ButtonInfo
import net.minecraftforge.fml.ExtensionPoint
import net.minecraftforge.fml.ModList
import net.minecraftforge.fml.common.Mod
import net.minecraftforge.fml.event.lifecycle.FMLClientSetupEvent
import net.minecraftforge.forgespi.language.ModFileScanData
import org.objectweb.asm.Type
import thedarkcolour.kotlinforforge.forge.FORGE_BUS
import thedarkcolour.kotlinforforge.forge.LOADING_CONTEXT
import thedarkcolour.kotlinforforge.forge.MOD_BUS
import java.util.function.BiFunction
import java.util.function.Supplier
import java.util.stream.Collectors

@Mod("snowygui")
@Suppress("UNUSED_PARAMETER")
class ForgeInit: Snowy() {
    private fun initSetup(event: FMLClientSetupEvent) = atInit()
    private fun configSetup(event: FMLClientSetupEvent) {
        LOADING_CONTEXT.registerExtensionPoint(
            ExtensionPoint.CONFIGGUIFACTORY,
            Supplier {
                return@Supplier BiFunction { mc, screen ->
                    return@BiFunction object : SnowyConfigScreen() {
                        override fun onClose() { mc.setScreen(screen) }
                    }
                }
            }
        )
    }
    init {
        annotatedButtons = ModList.get() // Forge-specific reflection
            .allScanData
            .stream()
            .map { obj: ModFileScanData -> obj.classes }
            .flatMap { obj: Set<ModFileScanData.ClassData?> -> obj.stream() }
            .filter { data: ModFileScanData.ClassData? ->
                (data!!.javaClass.getDeclaredField("clazz").apply { isAccessible = true }.get(data) as Type).className.let { classname ->
                    classname.startsWith(FeaturePackage).let {
                        it && with(Class.forName(classname)) {
                            (!kotlin.isAbstract || !kotlin.isData) && declaredAnnotations.any { annotation ->
                                annotation is ButtonInfo
                            }
                        }
                    }
                }
            }
            .map { Class.forName((it!!.javaClass.getDeclaredField("clazz").apply { isAccessible = true }.get(it) as Type).className) }
            .collect(Collectors.toSet())
        with(MOD_BUS) {
            addListener(this@ForgeInit::initSetup)
            addListener(this@ForgeInit::configSetup)
        }
        FORGE_BUS.register(HudHandler)
    }
}